package org.springblade.ftpdemo.task;

import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.AllArgsConstructor;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.ftpdemo.controller.SSHRemoteCall;
import org.springblade.ftpdemo.service.Method;
import org.springblade.ftpdemo.util.Constant;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.util.StopWatch;

import java.util.List;
import java.util.Vector;

/**
 * @author laifeng
 * @since 2022/12/1
 */
@Component
//@EnableScheduling
@AllArgsConstructor
public class TestTask {
    private final Method method;

//    @Scheduled(cron = "0/8 * * * * ? ")
    @XxlJob("demoJobHandler")
    public void refreshAliDeviceStatus() throws Exception {
        StopWatch stopWatch = new StopWatch("读取表6日志，生成加密文件，上传" );
        stopWatch.start();
        String yyyyMMdd = DateUtil.format(DateUtil.now(), "yyyyMMdd");

        method.creatSixUpFileAndUp(yyyyMMdd, "1");
        stopWatch.stop();
        double seconds = stopWatch.getTotalTimeSeconds();
        XxlJobHelper.log("XXL-JOB, 上传日志成功！ 共花费:",seconds);

    }
}
